Package: ATbounds
Type: Package
Title: Bounding Treatment Effects by Limited Information Pooling
Version: 0.1.1
Authors@R: c(
    person("Sokbae", "Lee", email = "sl3841@columbia.edu", role = c("aut", "cre")),
    person("Martin", "Weidner", email = "martin.weidner@economics.ox.ac.uk", role = "aut"))
Description: Estimation and inference methods for bounding average treatment effects (on the treated) that are valid under an unconfoundedness assumption. 
    The bounds are designed to be robust in challenging situations, for example, when the conditioning variables take on a large number of different values in the observed sample, or when the overlap condition is violated. 
    This robustness is achieved by only using limited "pooling" of information across observations. 
    For more details, see the paper by Lee and Weidner, "Bounding Treatment Effects by Pooling Limited Information across Observations," forthcoming at the Journal of Econometrics, <doi:10.48550/arXiv.2111.05243>.
License: GPL-3
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.2
Imports: stats, mgcv
Suggests: knitr, rmarkdown, testthat, ggplot2
VignetteBuilder: knitr
Depends: R (>= 2.10)
URL: https://github.com/ATbounds/ATbounds-r/,
        https://github.com/ATbounds/ATbounds-replication
BugReports: https://github.com/ATbounds/ATbounds-r/issues
NeedsCompilation: no
Packaged: 2026-05-07 22:30:18 UTC; sokbaelee
Author: Sokbae Lee [aut, cre],
  Martin Weidner [aut]
Maintainer: Sokbae Lee <sl3841@columbia.edu>
Repository: CRAN
Date/Publication: 2026-05-07 22:52:04 UTC
Built: R 4.6.0; ; 2026-05-08 01:48:33 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# ATbounds

<!-- badges: start -->

[![](https://cranlogs.r-pkg.org/badges/ATbounds)](https://cran.r-project.org/package=ATbounds)
[![codecov](https://codecov.io/gh/ATbounds/ATbounds-r/branch/master/graph/badge.svg)](https://app.codecov.io/gh/ATbounds/ATbounds-r)
<!-- badges: end -->

***ATbounds*** is an R package that provides estimation and inference
methods for bounding average treatment effects (on the treated) that are
valid under an unconfoundedness assumption. The bounds are designed to
be robust in challenging situations, for example, when the conditioning
variables take on a large number of different values in the observed
sample, or when the overlap condition is violated. This robustness is
achieved by only using limited “pooling” of information across
observations.

For more details, see Lee and Weidner, “Bounding Treatment Effects by
Pooling Limited Information across Observations,” forthcoming at the
*Journal of Econometrics* and available at [arXiv:2111.05243
\[econ.EM\]](https://arxiv.org/abs/2111.05243).

## Installation

You can install the released version of ***ATbounds*** from
[CRAN](https://CRAN.R-project.org) with:

``` r
install.packages("ATbounds")
```

Alternatively, you can install the development version from
[GitHub](https://github.com/) with:

``` r
# install.packages("devtools") if devtools is not installed
devtools::install_github("https://github.com/ATbounds/ATbounds-r")
```

## Documentation and Examples

The package vignette provides worked examples using the
NSW/Dehejia-Wahba, right heart catheterization, and electronic fetal
monitoring datasets. After installing the package, the vignette can be
opened in R with:

``` r
vignette("ATbounds_vignette", package = "ATbounds")
```

## Replication Materials

The companion repository
[ATbounds/ATbounds-replication](https://github.com/ATbounds/ATbounds-replication)
contains the replication materials for Lee and Weidner, “Bounding
Treatment Effects by Pooling Limited Information across Observations,”
forthcoming at the *Journal of Econometrics*.

The replication repository contains the scripts and generated outputs
used to reproduce the paper’s numerical results. It is separate from
this package repository: the vignette illustrates how to use the
***ATbounds*** package, while the replication repository reproduces the
paper tables and main-text numerical results.

## Reference

Lee, S. and Weidner, M. (forthcoming). “Bounding Treatment Effects by
Pooling Limited Information across Observations.” *Journal of
Econometrics*. [arXiv:2111.05243
\[econ.EM\]](https://arxiv.org/abs/2111.05243).

#' EFM
#'
#' The electronic fetal monitoring (EFM) and cesarean section (CS) dataset 
#' from Neutra, Greenland, and Friedman (1980) consists of observations on 14,484 women 
#' who delivered at Beth Israel Hospital, Boston from January 1970 to December 1975. 
#' The purpose of the study is to evaluate the impact of EFM on cesarean section (CS) rates. 
#' It is found by Neutra, Greenland, and Friedman (1980) that relevant confounding factors are: 
#' nulliparity (nullipar), arrest of labor progression (arrest), malpresentation (breech), and year of study (year). 
#' The dataset provided in the R package is from the supplementary materials of Richardson, Robins, and Wang (2017), 
#' who used this dataset to illustrate their proposed methods 
#' for modeling and estimating relative risk and risk difference. 
#' 
#' @references Neutra, R.R., Greenland, S. and Friedman, E.A., 1980. 
#' Effect of fetal monitoring on cesarean section rates. 
#' Obstetrics and gynecology, 55(2), pp.175-180.
#'
#' @references Richardson, T.S., Robins, J.M. and Wang, L., 2017. 
#' On modeling and estimation for the relative risk and risk difference. 
#' Journal of the American Statistical Association, 112(519), pp.1121-1130.
#' 
#' @format A data frame with 14484 rows and 6 variables:
#' \describe{
#' \item{cesarean}{Outcome: 1 if delivery was via cesarean section; 0 otherwise}
#' \item{monitor}{Treatment: 1 if electronic fetal monitoring (EFM) was used; 0 otherwise}
#' \item{arrest}{Covariate: 1 = arrest of labor progression; 0 otherwise}
#' \item{breech}{Covariate: 1 = malpresentation (breech); 0 otherwise}
#' \item{nullipar}{Covariate: 1 = nulliparity; 0 otherwise}
#' \item{year}{Year of study: 0,...,5 (actual values are 1970,...,1975)}
#' }
#' 
#' @source The dataset from Neutra, Greenland, and Friedman (1980) is available 
#' as part of supplementary materials of Richardson, Robins, and Wang (2017) 
#' on Journal of the American Statistical Association website at 
#' \doi{10.1080/01621459.2016.1192546}.
"EFM"

#' @title Simulating observations from the data-generating process considered in Lee and Weidner
#'
#' @description Simulates observations from the data-generating process considered in Lee and Weidner
#'
#' @param n sample size
#' @param ps_spec specification of the propensity score: "overlap" or "non-overlap" (default: "overlap")
#' @param x_discrete TRUE if the distribution of the covariate is uniform on the grid -3.0, -2.9, ..., 3.0 and
#'  FALSE if the distribution of the covariate is uniform on [-3,3] (default: FALSE)
#' 
#' @return An S3 object of type "ATbounds". The object has the following elements.
#' \item{outcome}{n observations of binary outcomes}
#' \item{treat}{n observations of binary treatments}
#' \item{covariate}{n observations of a scalar covariate}
#' \item{ate_oracle}{the sample analog of E[Y(1) - Y(0)]}
#' \item{att_oracle}{the sample analog of E[D * (Y(1) - Y(0)) | D = 1]}
#' 
#' @examples
#'   data <- simulation_dgp(100, ps_spec = "overlap")
#'   y <- data$outcome
#'   d <- data$treat
#'   x <- data$covariate
#'   ate <- data$ate_oracle
#'   att <- data$att_oracle
#'
#' @references Sokbae Lee and Martin Weidner. Bounding Treatment Effects by Pooling Limited Information across Observations. Forthcoming at the Journal of Econometrics.
#'
#' @export
simulation_dgp <- function(n, ps_spec = "overlap", x_discrete = FALSE){
    
  x <- stats::runif(n, min = -3, max = 3)
  
  if (x_discrete == TRUE){
      x <- round(x*10)/10 # discrete X in {-3.0, -2.9, ..., 3.0}  
  }
  
  if (ps_spec == "overlap"){  
    px <- 0.5
  } else if (ps_spec == "non-overlap"){
    px <- 0.25*(x >= 2) + 0.5*(abs(x) < 2) 
  }
  
  treat <- as.integer(px < stats::runif(n)) # treat = 1 always if x <= -2 for the non-overlap case
  
  ps <- 1-px
  
  y_1 <- 1 + px + stats::rnorm(n)
  y_0 <- px + stats::rnorm(n)
  y_1  <- as.integer(y_1 > 0)
  y_0  <- as.integer(y_0 > 0)
  
  y <- treat*y_1 + (1-treat)*y_0
  
  ate_oracle <- mean(y_1 - y_0)
  att_oracle <- mean(treat*(y_1-y_0))/mean(ps)
  
  outputs <- list("outcome"=y,"treat"=treat,"covariate"=x,
                  "ate_oracle"=ate_oracle,"att_oracle"=att_oracle)
  
  class(outputs) = 'ATbounds'

outputs    
}

context("Testing ATbounds: simulation_dgp")

test_that("ATE-oracle and the mean difference estimator should be similar when P(D=1|X) = 0.5", {
  set.seed(1)
  data <- simulation_dgp(10000, ps_spec = "overlap")
  y <- data$outcome
  d <- data$treat
  ate <- data$ate_oracle
  mde <- mean(d*y)/mean(d) - mean((1-d)*y)/mean(1-d)
  diff <- (abs(ate - mde) <= 1e-2)

  expect_true(diff)
  
})

test_that("ATE-oracle and the mean difference estimator should be different when P(D=1|X) is a function of X", {
  set.seed(1)
  data <- simulation_dgp(10000, ps_spec = "non-overlap")
  y <- data$outcome
  d <- data$treat
  ate <- data$ate_oracle
  mde <- mean(d*y)/mean(d) - mean((1-d)*y)/mean(1-d)
  diff <- (abs(ate - mde) <= 1e-2)
  
  expect_false(diff)
  
})

test_that("Discrete and continuous cases are different", {
  set.seed(1)
  data_d <- simulation_dgp(100, ps_spec = "non-overlap", x_discrete = TRUE)
  set.seed(1)
  data_c <- simulation_dgp(100, ps_spec = "non-overlap")
  expect_false(data_c$covariate[1] == data_d$covariate[1])
  
})

#' @title Bounding the average treatment effect on the treated (ATT) 
#'
#' @description Bounds the average treatment effect on the treated (ATT) under the unconfoundedness assumption without the overlap condition.
#'
#' @param Y n-dimensional vector of binary outcomes
#' @param D n-dimensional vector of binary treatments
#' @param X n by p matrix of covariates
#' @param rps n-dimensional vector of the reference propensity score
#' @param Q bandwidth parameter that determines the maximum number of observations for pooling information (default: Q = 3)
#' @param studentize TRUE if X is studentized elementwise and FALSE if not (default: TRUE)
#' @param alpha (1-alpha) nominal coverage probability for the confidence interval of ATE (default: 0.05)
#' @param x_discrete TRUE if the distribution of X is discrete and FALSE otherwise (default: FALSE)
#' @param n_hc number of hierarchical clusters to discretize non-discrete covariates; relevant only if x_discrete is FALSE.
#' The default choice is n_hc = ceiling(length(Y)/10), so that there are 10 observations in each cluster on average. 
#' 
#' @return An S3 object of type "ATbounds". The object has the following elements.
#' \item{call}{a call in which all of the specified arguments are specified by their full names}
#' \item{type}{ATT}
#' \item{cov_prob}{Confidence level: 1-alpha}
#' \item{est_lb}{estimate of the lower bound on ATT, i.e. E[Y(1) - Y(0) | D = 1]}
#' \item{est_ub}{estimate of the upper bound on ATT, i.e. E[Y(1) - Y(0) | D = 1]}
#' \item{est_rps}{the point estimate of ATT using the reference propensity score}
#' \item{se_lb}{standard error for the estimate of the lower bound on ATT}
#' \item{se_ub}{standard error for the estimate of the upper bound on ATT}
#' \item{ci_lb}{the lower end point of the confidence interval for ATT}
#' \item{ci_ub}{the upper end point of the confidence interval for ATT}
#' 
#' @examples
#'   Y <- RHC[,"survival"]
#'   D <- RHC[,"RHC"]
#'   X <- RHC[,c("age","edu")]
#'   rps <- rep(mean(D),length(D))
#'   results_att <- attbounds(Y, D, X, rps, Q = 3)
#'
#' @references Sokbae Lee and Martin Weidner. Bounding Treatment Effects by Pooling Limited Information across Observations. Forthcoming at the Journal of Econometrics.
#'
#' @export
attbounds <- function(Y, D, X, rps, Q = 3L, studentize = TRUE, alpha = 0.05, x_discrete = FALSE, n_hc = NULL){

  call <- match.call()
  
  X <- as.matrix(X)
  if (studentize == TRUE){
    X <- scale(X)  # centers and scales the columns of X
  }  
  
  n <- nrow(X)
  ymin <- min(Y)
  ymax <- max(Y)
  
  if (is.null(n_hc) == TRUE){ 
    n_hc = ceiling(n/10)  # number of clusters  
  }  
  
  ### ATT estimation using reference propensity scores  ###    
  
  rps_wt <- rps/(1-rps)      
  att_rps <- sum(D*Y-rps_wt*(1-D)*Y)/sum(D) 

  if (x_discrete == FALSE){  # Computing weights with non-discrete covariates
    
    hc <- stats::hclust(stats::dist(X), method = "complete")  # hierarchical cluster
    ind_Xunique <- stats::cutree(hc, k = n_hc)                # An index vector that has the same dimension as that of X
    mx <- n_hc
    
  } else if (x_discrete == TRUE){  # Computing weights with discrete covariates
    
    Xunique <- mgcv::uniquecombs(X)       # A matrix of unique rows from X
    ind_Xunique <- attr(Xunique,"index")  # An index vector that has the same dimension as that of X
    mx <- nrow(Xunique)                   # number of unique rows 
    
  } else {
    stop("x_discrete must be either TRUE or FALSE.") 
  }
  
  res <- matrix(NA,nrow=mx,ncol=2)
      
  for (i in 1:mx){ # loop over support points
    
      disc_ind <- (ind_Xunique == i) 
      nx <- sum(disc_ind)    # number of obs. such that X_i = x for each row of x
      nx1 <- sum(D*disc_ind) # number of obs. such that X_i = x and D_i = 1 for each row of x
      nx0 <- nx - nx1        # number of obs. such that X_i = x and D_i = 0 for each row of x
      
      nx1 <- nx1 + (nx1 == 0) # replace nx1 with 1 when it is zero to avoid NaN 
      nx0 <- nx0 + (nx0 == 0) # replace nx0 with 1 when it is zero to avoid NaN 
      
      y1bar <- (sum(D*Y*disc_ind)/nx1)     # Dividing by zero never occurs because the numerator is zero whenever nx1 is zero  
      y0bar <- (sum((1-D)*Y*disc_ind)/nx0) # Dividing by zero never occurs because the numerator is zero whenever nx0 is zero 
      
      # Computing weights

      if (Q >= 1){

          qq <- min(Q,nx)
          k_upper <- 2*floor(qq/2)
          v_x0 <- nx1/nx

          rps_x <- rps[disc_ind]
          
          if (x_discrete == FALSE){ 
            rps_x <- mean(rps_x)  # if X is non-discrete, take the average
          } else if (x_discrete == TRUE){
            rps_x <- unique(rps_x)
            if (length(rps_x) > 1){
              stop("The reference propensity score should be unique for the same value of X if X is discrete.")   
            }
          }              
          
          for (k in 0:k_upper){
              
              px0k <- (rps_x/(rps_x-1))^k
              
              if ((qq %% 2) == 1){ # if min(q,nx) is odd
                
                term_x0 <- ((nx - nx0)/nx)*(1/choose(nx-1,qq-1))*choose(nx0,k)*choose(nx-1-nx0,qq-1-k)
                
              } else if ((qq %% 2) == 0){ # if min(q,nx) is even
                
                term_x0 <- (1/choose(nx,qq))*choose(nx0,k)*choose(nx-nx0,qq-k)
                
              } else{
                stop("'min(q,nx)' must be a positive integer.")      
              }  
              
              omega0 <- px0k*term_x0

              v_x0 <- v_x0 - omega0
          }

       } else{
         stop("'Q' must be a positive integer.")      
       }
        
       res[i,1] <- ((mx*nx)/n)*((nx1/nx)*(y1bar - ymax) - v_x0*(y0bar - ymax))
       res[i,2] <- ((mx*nx)/n)*((nx1/nx)*(y1bar - ymin) - v_x0*(y0bar - ymin))
   } 
    
  ### Obtain bound estimates ###
  
  meanD <- mean(D)
  est <- apply(res,2,mean)
  att_lb <- est[1]/meanD
  att_ub <- est[2]/meanD
  
  # Standard errors
  ift <- res/meanD - ((mx*nx)/n)*est/(meanD^2)
  se <- apply(ift,2,stats::sd)
  se_lb <- se[1]/sqrt(mx)
  se_ub <- se[2]/sqrt(mx)

  # Stoye (2020) construction
  two_sided <- 1-alpha/2
  cv_norm <- stats::qnorm(two_sided)
  ci1_lb <- att_lb - cv_norm*se_lb
  ci1_ub <- att_ub + cv_norm*se_ub

  att_star <- (se_ub*att_lb + se_lb*att_ub)/(se_lb + se_ub)
  se_star <- 2*(se_lb*se_ub)/(se_lb + se_ub) # This corresponds to rho=1 in Stoye (2020)
  ci2_lb <- att_star - cv_norm*se_star
  ci2_ub <- att_star + cv_norm*se_star

  if (ci1_lb <= ci1_ub){ # if the first confidence interval is non-empty
    ci_lb <- min(ci1_lb,ci2_lb)
    ci_ub <- max(ci1_ub,ci2_ub)
  } else {
    ci_lb <- ci2_lb
    ci_ub <- ci2_ub  
  }
  
  outputs = list(call = call, type = "ATT", cov_prob = (1-alpha),
                 "est_lb"=att_lb,"est_ub"=att_ub,"es_rps"=att_rps,
                 "se_lb"=se_lb,"se_ub"=se_ub,"ci_lb"=ci_lb,"ci_ub"=ci_ub)  

  class(outputs) = 'ATbounds'

  outputs
}

context("Testing ATbounds::attbounds")

Y <- RHC[,"survival"]
D <- RHC[,"RHC"]
age <- round(RHC[,"age"])
female <- RHC[,"sex_Female"]
X <- cbind(age,female)
rps <- rep(mean(D),length(D))

test_that("Q must be strictly positive", {
  
  expect_error(attbounds(Y, D, X, rps, Q = 0))
  
})

test_that("Checking the summary results", {
  
  sum = summary(attbounds(Y, D, X, rps))
  expect_named(sum, c("Lower_Bound","Upper_Bound"))
  
})

test_that("'x_discrete' must be either TRUE or FALSE", {
  
  expect_error(attbounds(Y, D, X, rps, x_discrete=Maybe))
  
})

Y_EFM <- EFM[,"cesarean"]
D_EFM <- EFM[,"monitor"]
X_EFM <- as.matrix(EFM[,c("arrest", "breech", "nullipar", "year")])
rps_EFM <- rep(mean(D_EFM),length(D_EFM))  

test_that("Different Q generates different results", {
  
  res1 <- attbounds(Y_EFM, D_EFM, X_EFM, rps_EFM, Q=3, x_discrete=TRUE)
  res2 <- attbounds(Y_EFM, D_EFM, X_EFM, rps_EFM, Q=4, x_discrete=TRUE)
  
  expect_false(res1$ci_lb == res2$ci_lb)
  
})

#' RHC
#'
#' The right heart catheterization (RHC) dataset is publicly available on the Vanderbilt Biostatistics website.
#' RHC is a diagnostic procedure for directly measuring cardiac function in critically ill patients. 
#' The dependent variable is 1 if a patient survived after 30 days of admission, 0 if a patient died within 30 days.
#' The treatment variable is 1 if RHC was applied within 24 hours of admission, and 0 otherwise.
#' The sample size was n = 5735, and 2184 patients were treated with RHC. 
#' Connors et al. (1996) used a propensity score matching approach to study the efficacy of RHC,
#' using data from the observational study called SUPPORT (Murphy and Cluff, 1990). 
#' Many authors used this dataset subsequently.
#' The 72 covariates are constructed, following Hirano and Imbens (2001).
#' 
#' @references Connors, A.F., Speroff, T., Dawson, N.V., Thomas, C., Harrell, F.E., Wagner, D., Desbiens, N., Goldman, L., Wu, A.W., Califf, R.M. and Fulkerson, W.J., 1996. 
#' The effectiveness of right heart catheterization in the initial care of critically III patients. JAMA, 276(11), pp.889-897.
#' \doi{10.1001/jama.1996.03540110043030}
#'
#' @references Hirano, K., Imbens, G.W. Estimation of Causal Effects using Propensity Score Weighting: An Application to Data on Right Heart Catheterization, 2001.
#' Health Services & Outcomes Research Methodology 2, pp.259–278. 
#' \doi{10.1023/A:1020371312283}
#' 
#' @references D. J. Murphy, L. E. Cluff, SUPPORT: Study to understand prognoses and preferences for outcomes and risks of treatments—study design, 1990.
#' Journal of Clinical Epidemiology, 43, pp. 1S–123S
#' \url{https://www.jclinepi.com/issue/S0895-4356(00)X0189-8}
#' .
#' @format A data frame with 5735 rows and 74 variables:
#' \describe{
#' \item{survival}{Outcome: 1 if a patient survived after 30 days of admission, and 0 if a patient died within 30 days}
#' \item{RHC}{Treatment: 1 if RHC was applied within 24 hours of admission, and 0 otherwise.}
#' \item{age}{Age in years}
#' \item{edu}{Years of education}
#' \item{cardiohx}{Cardiovascular symptoms}
#' \item{chfhx}{Congestive Heart Failure}
#' \item{dementhx}{Dementia, stroke or cerebral infarct, Parkinson’s disease}
#' \item{psychhx}{Psychiatric history, active psychosis or severe depression}
#' \item{chrpulhx}{Chronic pulmonary disease, severe pulmonary disease}
#' \item{renalhx}{Chronic renal disease, chronic hemodialysis or peritoneal dialysis}
#' \item{liverhx}{Cirrhosis, hepatic failure}
#' \item{gibledhx}{Upper GI bleeding}
#' \item{malighx}{Solid tumor, metastatic disease, chronic leukemia/myeloma, acute leukemia, lymphoma}
#' \item{immunhx}{Immunosuppression, organ transplant, HIV, Diabetes Mellitus, Connective Tissue Disease}
#' \item{transhx}{transfer (> 24 hours) from another hospital}
#' \item{amihx}{Definite myocardial infarction}
#' \item{das2d3pc}{DASI - Duke Activity Status Index}
#' \item{surv2md1}{Estimate of prob. of surviving 2 months}
#' \item{aps1}{APACHE score}
#' \item{scoma1}{Glasgow coma score}
#' \item{wtkilo1}{Weight}
#' \item{temp1}{Temperature}
#' \item{meanbp1}{Mean Blood Pressure}
#' \item{resp1}{Respiratory Rate}
#' \item{hrt1}{Heart Rate}
#' \item{pafi1}{PaO2/FI02 ratio}
#' \item{paco21}{PaCO2}
#' \item{ph1}{PH}
#' \item{wblc1}{WBC}
#' \item{hema1}{Hematocrit}
#' \item{sod1}{Sodium}
#' \item{pot1}{Potassium}
#' \item{crea1}{Creatinine}
#' \item{bili1}{Bilirubin}
#' \item{alb1}{Albumin}
#' \item{cat1_CHF}{1 if the primary disease category is CHF, and 0 otherwise (Omitted category = ARF).}
#' \item{cat1_Cirrhosis}{1 if the primary disease category is Cirrhosis, and 0 otherwise (Omitted category = ARF).}
#' \item{cat1_Colon_Cancer}{1 if the primary disease category is Colon Cancer, and 0 otherwise (Omitted category = ARF).}
#' \item{cat1_Coma}{1 if the primary disease category is Coma, and 0 otherwise (Omitted category = ARF).}
#' \item{cat1_COPD}{1 if the primary disease category is COPD, and 0 otherwise (Omitted category = ARF).}
#' \item{cat1_Lung_Cancer}{1 if the primary disease category is Lung Cancer, and 0 otherwise (Omitted category = ARF).}
#' \item{cat1_MOSF_Malignancy}{1 if the primary disease category is MOSF w/Malignancy, and 0 otherwise (Omitted category = ARF).}
#' \item{cat1_MOSF_Sepsis}{1 if the primary disease category is MOSF w/Sepsis, and 0 otherwise (Omitted category = ARF).}
#' \item{ca_Metastatic}{1 if cancer is metastatic, and 0 otherwise (Omitted category = no cancer).}
#' \item{ca_Yes}{1 if cancer is localized, and 0 otherwise (Omitted category = no cancer).}
#' \item{ninsclas_Medicaid}{1 if medical insurance category is Medicaid, and 0 otherwise (Omitted category = Private).}
#' \item{ninsclas_Medicare}{1 if medical insurance category is Medicare, and 0 otherwise (Omitted category = Private).}
#' \item{ninsclas_Medicare_and_Medicaid}{1 if medical insurance category is Medicare & Medicaid, and 0 otherwise (Omitted category = Private).}
#' \item{ninsclas_No_insurance}{1 if medical insurance category is No Insurance, and 0 otherwise (Omitted category = Private).}
#' \item{ninsclas_Private_and_Medicare}{1 if medical insurance category is Private & Medicare, and 0 otherwise (Omitted category = Private).}
#' \item{race_black}{1 if Black, and 0 otherwise (Omitted category = White).}
#' \item{race_other}{1 if Other, and 0 otherwise (Omitted category = White).}
#' \item{income3}{1 if Income >$50k, and 0 otherwise (Omitted category = under $11k).}
#' \item{income1}{1 if Income $11–$25k, and 0 otherwise (Omitted category = under $11k).}
#' \item{income2}{1 if Income $25–$50k, and 0 otherwise (Omitted category = under $11k).}
#' \item{resp_Yes}{Respiratory diagnosis}
#' \item{card_Yes}{Cardiovascular diagnosis}
#' \item{neuro_Yes}{Neurological diagnosis}
#' \item{gastr_Yes}{Gastrointestinal diagnosis}
#' \item{renal_Yes}{Renal diagnosis}
#' \item{meta_Yes}{Metabolic diagnosis}
#' \item{hema_Yes}{Hematological diagnosis}
#' \item{seps_Yes}{Sepsis diagnosis}
#' \item{trauma_Yes}{Trauma diagnosis}
#' \item{ortho_Yes}{Orthopedic diagnosis}
#' \item{dnr1_Yes}{Do Not Resuscitate status on day 1}
#' \item{sex_Female}{Female}
#' \item{cat2_Cirrhosis}{1 if the secondary disease category is Cirrhosis, and 0 otherwise (Omitted category = NA).}
#' \item{cat2_Colon_Cancer}{1 if secondary disease category is Colon Cancer, and 0 otherwise (Omitted category = NA).}
#' \item{cat2_Coma}{1 if the secondary disease category is Coma, and 0 otherwise (Omitted category = NA).}
#' \item{cat2_Lung_Cancer}{1 if the secondary disease category is Lung Cancer, and 0 otherwise (Omitted category = NA).}
#' \item{cat2_MOSF_Malignancy}{1 if the secondary disease category is MOSF w/Malignancy, and 0 otherwise (Omitted category = NA).}
#' \item{cat2_MOSF_Sepsis}{1 if the secondary disease category is MOSF w/Sepsis, and 0 otherwise (Omitted category = NA).}
#' \item{wt0}{weight = 0 (missing)}
#' }
#' 
#' @source The dataset is publicly available on the Vanderbilt Biostatistics website at 
#' \url{https://hbiostat.org/data/}.
"RHC"

#' @title Summary method for ATbounds objects
#'
#' @description Produce a summary for an ATbounds object.

#' @param object ATbounds object
#' @param ... Additional arguments for summary generic
#' 
#' @return A summary is produced with bounds estimates and confidence intervals.
#' In addition, it has the following elements.
#' \item{Lower_Bound}{lower bound estimate and lower end point of the confidence interval}
#' \item{Upper_Bound}{upper bound estimate and upper end point of the confidence interval}
#' 
#' @examples
#'   Y <- RHC[,"survival"]
#'   D <- RHC[,"RHC"]
#'   X <- RHC[,c("age","edu")]
#'   rps <- rep(mean(D),length(D))
#'   results_ate <- atebounds(Y, D, X, rps, Q = 3)
#'   summary(results_ate)
#'
#' @references Sokbae Lee and Martin Weidner. Bounding Treatment Effects by Pooling Limited Information across Observations. Forthcoming at the Journal of Econometrics.
#'
#' @export
summary.ATbounds <- function(object,...){

  heading=c(paste("ATbounds: ",object$type,sep=""),
            paste("Call:",format(object$call)),
            paste("Confidence Level:", format(object$cov_prob)))
  
  est_lb = object$est_lb
  est_ub = object$est_ub
  ci_lb = object$ci_lb
  ci_ub = object$ci_ub
  
  sumob = data.frame(Lower_Bound = c(est_lb,ci_lb), Upper_Bound = c(est_ub,ci_ub), 
                     row.names = c("Bound Estimate", "Confidence Interval"))
  
  structure(sumob,heading=heading,class=c("anova","data.frame"))
  
}

---
title: "ATbounds: An R Vignette"
author: "Sokbae Lee and Martin Weidner"
abstract: ATbounds is an R package that provides estimation and inference methods for bounding average treatment effects (on the treated) that are valid under an unconfoundedness assumption. The bounds are designed to be robust in challenging situations, for example, when the conditioning variables take on a large number of different values in the observed sample, or when the overlap condition is violated. This robustness is achieved by only using limited "pooling" of information across observations.
output: rmarkdown::pdf_document
bibliography: refs.bib 
vignette: >
  %\VignetteIndexEntry{ATbounds: An R Vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

## Introduction

__ATbounds__ is an R package that provides estimation and inference methods for bounding average treatment effects (on the treated) that are valid under an unconfoundedness assumption. The bounds are designed to be robust in challenging situations, for example, when the conditioning variables take on a large number of different values in the observed sample, or when the overlap condition is violated. This robustness is achieved by only using limited "pooling" of information across observations. Namely, the bounds are constructed as sample averages over functions of the observed outcomes such that the contribution of each outcome only depends on the treatment status of a limited number of observations. No information pooling across observations leads to so-called "Manski bounds" [@manski1989anatomy; @manski1990nonparametric], while unlimited information pooling leads to standard inverse propensity score weighting. The ATbounds package provides inference methods for exploring the intermediate range between these two extremes.

The methodology used in the ATbounds package is described in detail in Lee and Weidner, "Bounding Treatment Effects by Pooling Limited Information across Observations," forthcoming at the *Journal of Econometrics* and available at <https://arxiv.org/abs/2111.05243>.

We begin by calling the ATbounds package.

```{r setup}
library(ATbounds)
```

# Case Study 1: Bounding the Effects of a Job Training Program

To illustrate the usefulness of the package, we first use the well-known 
@LaLonde-AER dataset available on Rajeev Dehejia's web page 
at <http://users.nber.org/~rdehejia/nswdata2.html>.
The code in this case study is displayed but not evaluated during package checks because it downloads data from an external website. The companion replication repository contains scripts for reproducing these results.

```{r nsw-eval-options, include=FALSE}
knitr::opts_chunk$set(eval = FALSE, purl = FALSE)
```

## LaLonde's Experimental Sample 

We first look at LaLonde's original experimental sample.

```{r, eval=FALSE, purl=FALSE}
  nsw_treated <- read.table("http://users.nber.org/~rdehejia/data/nsw_treated.txt")
  colnames(nsw_treated) <- c("treat","age","edu","black","hispanic",
                           "married","nodegree","RE75","RE78")

  nsw_control <- read.table("http://users.nber.org/~rdehejia/data/nsw_control.txt")
  colnames(nsw_control) <- c("treat","age","edu","black","hispanic",
                           "married","nodegree","RE75","RE78")

```

The outcome variable is `RE78` (earnings in 1978). The binary treatment indicator is `treat` (1 if treated, 0 if not treated). We now combine the treatment and control samples and define the variables.

```{r, eval=FALSE, purl=FALSE}
  nsw <- rbind(nsw_treated,nsw_control)
  attach(nsw)
  D <- treat  
  Y <- (RE78 > 0) 
```

In this vignette, we define the outcome to be whether employed in 1978 (that is, earnings in 1978 are positive). 

The LaLonde dataset is from the National Supported Work Demonstration (NSW), which is a randomized controlled temporary employment program. In view of that, we set the reference propensity score to be independent of covariates. 

```{r, eval=FALSE, purl=FALSE}
  rps <- rep(mean(D),length(D))  
```

The average treatment effect is obtained by 

```{r, eval=FALSE, purl=FALSE}
  ate_nsw <- mean(D*Y)/mean(D)-mean((1-D)*Y)/mean(1-D)
  print(ate_nsw)
```

Alternatively, we run simple regression

```{r, eval=FALSE, purl=FALSE}
  model <- lm(Y ~ D)
  summary(model)
  confint(model)
```

The 95% confidence interval $[0.01,0.14]$ is rather wide but excludes zero. 

## Dehejia-Wahba Sample 

@DehejiaWahba-JASA and @DehejiaWahba-RESTAT extract a further subset of LaLonde's NSW experimental data to obtain a subset containing information on RE74 (earnings in 1974). 

```{r, eval=FALSE, purl=FALSE}
  detach(nsw)
  nswre_treated <- read.table("http://users.nber.org/~rdehejia/data/nswre74_treated.txt")
  colnames(nswre_treated) <- c("treat","age","edu","black","hispanic",
                           "married","nodegree","RE74","RE75","RE78")

  nswre_control <- read.table("http://users.nber.org/~rdehejia/data/nswre74_control.txt")
  colnames(nswre_control) <- c("treat","age","edu","black","hispanic",
                           "married","nodegree","RE74","RE75","RE78")
  nswre <- rbind(nswre_treated,nswre_control)
  attach(nswre)
  D <- treat  
  Y <- (RE78 > 0) 
  X <- cbind(age,edu,black,hispanic,married,nodegree,RE74/1000,RE75/1000)
```

The covariates are as follows:

* `age`: age in years,
* `edu`:  years of education,
* `black`: 1 if black, 0 otherwise, 
* `hispanic`: 1 if Hispanic, 0 otherwise, 
* `married`: 1 if married, 0 otherwise, 
* `nodegree`: 1 if no degree, 0 otherwise, 
* `RE74`: earnings in 1974, 
* `RE75`: earnings in 1975. 

If we assume that the Dehejia-Wahba sample still preserves initial randomization, we can
set the reference propensity score to be independent of covariates. However, it may not be the case and therefore, our approach can provide a robust method to check whether the Dehejia-Wahba sample can be viewed as a random sample from a randomized controlled experiment.

We first define the reference propensity score.

```{r, eval=FALSE, purl=FALSE}
  rps <- rep(mean(D),length(D))  
```

Using this reference propensity score, the average treatment effect is obtained by 

```{r, eval=FALSE, purl=FALSE}
  ate_nswre <- mean(D*Y)/mean(D)-mean((1-D)*Y)/mean(1-D)
  print(ate_nswre)
```

Alternatively, we run simple regression

```{r, eval=FALSE, purl=FALSE}
  model <- lm(Y ~ D)
  summary(model)
  confint(model)
```

The resulting 95% confidence interval $[0.02,0.20]$ is wide but again excludes zero. 

### Bounds on ATE

We now introduce our bounds on the average treatment effect (ATE). 

```{r, eval=FALSE, purl=FALSE}
  bns_nsw <- atebounds(Y, D, X, rps)
```

In implementing `atebounds`, there are several options:

* `Q`: bandwidth parameter that determines the maximum number of observations for pooling information (default: $Q = 3$)

* `studentize`: `TRUE` if `X` is studentized elementwise and `FALSE` if not (default: `TRUE`)

* `alpha`: $(1-\alpha)$ nominal coverage probability for the confidence interval of ATE (default: 0.05)

* `discrete`: `TRUE` if `X` includes only discrete covariates and `FALSE` if not (default: `FALSE`)

* `n_hc`: number of hierarchical clusters to discretize non-discrete covariates; relevant only if x_discrete is FALSE. The default choice is `n_hc = ceiling(length(Y)/10)`, so that there are 10 observations in each cluster on average.

The clusters are constructed via hierarchical, agglomerative clustering with complete linkage, where the distance is measured by the Euclidean distance after studentizing each of the covariates. As mentioned above, the number $m$ of clusters is set by $$m = \left\lceil \frac{n}{L} \right\rceil$$ for $L = 10$.

We show the summary results saved in `bns_nsw`.

```{r, eval=FALSE, purl=FALSE}
  summary(bns_nsw)
```

Note that the estimate of the lower bound is larger than that of the upper bound. 
This crossing problem can occur in finite samples due to random sampling errors. 
While statistical theory guarantees that this problem cannot occur asymptotically,
it is desirable to have a non-empty confidence interval in applications.
We therefore use the method in @stoye2020 to obtain a valid confidence interval that is never empty.


The 95% confidence interval $[-0.01,0.19]$ obtained here is similar to the previous interval $[0.02,0.20]$, which was obtained under the assumption that the Dehejia-Wahba sample is a random sample from NSW. This suggests that first, there is no evidence against violation of the random sampling assumption in the Dehejia-Wahba sample and second, our inference method does not suffer from unduly enlargement of the confidence interval to achieve robustness, although a null effect is now included in our confidence interval.

With $Q=2$, the bounds for ATE are
```{r, eval=FALSE, purl=FALSE}
summary(atebounds(Y, D, X, rps, Q = 2))
```

With $Q=4$, the bounds for ATE are
```{r, eval=FALSE, purl=FALSE}
summary(atebounds(Y, D, X, rps, Q = 4))
```


Recall that the point estimate of ATE under the random sampling assumption was

```{r, eval=FALSE, purl=FALSE}
print(ate_nswre)
```

Thus, the ATE estimate based on the simple mean difference well within the 95% confidence intervals across $Q=2, 3, 4$. 

Recall that covariates $X$ include non-discrete variables: `RE74` and `RE75`. As a default option, `atebounds` chooses the number of hierarchical clusters to be `n_hc = ceiling(length(Y)/10)`.
To check sensitivity to `n_hc`, we now run the following:

```{r, eval=FALSE, purl=FALSE}
summary(atebounds(Y, D, X, rps))
summary(atebounds(Y, D, X, rps, n_hc = ceiling(length(Y)/5)))
summary(atebounds(Y, D, X, rps, n_hc = ceiling(length(Y)/20)))
```

It can be seen that the alternative estimation result is more similar to the default one with `n_hc = ceiling(length(Y)/20)` than with `n_hc = ceiling(length(Y)/5)`. Overall, the results are qualitatively similar across the three different specifications of `n_hc`.  

Finally, to see what is saved in `bns_nsw`, we now print it out.

```{r, eval=FALSE, purl=FALSE}
  print(bns_nsw)
```

The output list contains: 

* `call`: a call in which all of the specified arguments are specified by their full names
* `type`: ATE
* `cov_prob`: confidence level ($1-\alpha$)
* `y1_lb`: estimate of the lower bound on the average of $Y(1)$, i.e. $\mathbb{E}[Y(1)]$,
* `y1_ub`: estimate of the upper bound on the average of $Y(1)$, i.e. $\mathbb{E}[Y(1)]$,
* `y0_lb`: estimate of the lower bound on the average of $Y(0)$, i.e. $\mathbb{E}[Y(0)]$,
* `y0_ub`: estimate of the upper bound on the average of $Y(0)$, i.e. $\mathbb{E}[Y(0)]$,
* `est_lb`: estimate of the lower bound on ATE, i.e. $\mathbb{E}[Y(1) - Y(0)]$,
* `est_ub`: estimate of the upper bound on ATE, i.e. $\mathbb{E}[Y(1) - Y(0)]$,
* `est_rps`: the point estimate of ATE using the reference propensity score,
* `se_lb`: standard error for the estimate on the lower bound on ATE,
* `se_ub`: standard error for the estimate of the upper bound on ATE,
* `ci_lb`: the lower end point of the confidence interval for ATE,
* `ci_ub`: the upper end point of the confidence interval for ATE.

### Bounds on ATT

We now look at bounds on the average treatment effect on the treated (ATT). 

```{r, eval=FALSE, purl=FALSE}
  bns_nsw_att <- attbounds(Y, D, X, rps)
  summary(bns_nsw_att)
```

We experiment with `Q`.

```{r, eval=FALSE, purl=FALSE}
  summary(attbounds(Y, D, X, rps, Q = 2))
```

```{r, eval=FALSE, purl=FALSE}
  summary(attbounds(Y, D, X, rps, Q = 4))
```

We also experiment with `n_hc`.

```{r, eval=FALSE, purl=FALSE}
summary(attbounds(Y, D, X, rps))
summary(attbounds(Y, D, X, rps, n_hc = ceiling(length(Y)/5)))
summary(attbounds(Y, D, X, rps, n_hc = ceiling(length(Y)/20)))
```

Bound estimates cross (that is, the lower bound is larger than the upper bound) and furthermore sensitive to the choice of `Q` and `n_hc`. This is likely to be driven by the relatively small sample size. However, once we factor into sampling uncertainty and look at the confidence intervals, all the results are more or less similar. 

## NSW treated and PSID control 

The Dehejia-Wahba sample can be regarded as a data scenario where the propensity score is known and satisfies the overlap condition. We now turn to a different data scenario where it is likely that the propensity score is unknown and may not satisfy the overlap condition. 


```{r, eval=FALSE, purl=FALSE}
  psid2_control <- read.table("http://users.nber.org/~rdehejia/data/psid2_controls.txt")
  colnames(psid2_control) <- c("treat","age","edu","black","hispanic",
                           "married","nodegree","RE74","RE75","RE78")
  psid <- rbind(nswre_treated,psid2_control)
  detach(nswre)
  attach(psid)
  D <- treat  
  Y <- (RE78 > 0) 
  X <- cbind(age,edu,black,hispanic,married,nodegree,RE74/1000,RE75/1000)
```

Here, we use one of non-experimental comparison groups constructed by LaLonde from the Population Survey of Income Dynamics, namely PSID2 controls. We now estimate the reference propensity score using the sample proportion and obtain the new bound estimates:

```{r, eval=FALSE, purl=FALSE}
  rps_sp <- rep(mean(D),length(D))  
  bns_psid <- atebounds(Y, D, X, rps_sp)
  summary(bns_psid)
```

The confidence interval $[-0.35,0.31]$ here is much larger than the confidence interval $[-0.01,0.19]$ with the Dehejia-Wahba sample. It is worth noting that the sample proportion is unlikely to be correctly specified in the NSW-treated/PSID-control sample. Thus, it seems that our inference method produces a wider confidence interval in order to be robust against misspecification of the propensity scores.     

We now consider the Manski bounds, which can be obtained by setting $Q = 1$. 

```{r, eval=FALSE, purl=FALSE}
  summary(atebounds(Y, D, X, rps_sp, Q=1))
```

We can see that the Manski bounds are even larger and the same regardless of the specification of the reference propensity scores. Recall the Manski bounds do not impose the unconfoundedness assumption and do not rely on any pooling information (hence, it does not matter how to specify the reference propensity score).   

Finally, we obtain the bounds for the average treatment effect on the treated (ATT).

```{r, eval=FALSE, purl=FALSE}
  summary(attbounds(Y, D, X, rps_sp))
  detach(psid)
```

We find that the bounds on ATT are wide, as in ATE.


# Case Study 2: Bounding the Effect of Right Heart Catheterization 

```{r packaged-data-eval-options, include=FALSE, eval=TRUE, purl=TRUE}
knitr::opts_chunk$set(eval = TRUE, purl = TRUE)
```

As a second empirical example, we revisit the well-known Right Heart Catheterization Dataset. 
In particular, we apply our methods to @Connors1996's study of the
efficacy of right heart catheterization (RHC), which is a diagnostic
procedure for directly measuring cardiac function in critically ill
patients. This dataset has been subsequently used in the context of
limited overlap by @crump2009dealing, @Rothe:2017, and
@Li-et-al:2018 among others. The dataset is publicly available on the
Vanderbilt Biostatistics website at
<https://hbiostat.org/data>.

In this example, the dependent variable is 1 if a patient survived after
30 days of admission, and 0 if a patient died within 30 days. The binary
treatment variable is 1 if RHC was applied within 24 hours of admission,
and 0 otherwise. The sample size was $n = 5735$, and 2184 patients were
treated with RHC. There are a large number of covariates:
@hirano2001estimation constructed 72 variables from the dataset and
the same number of covariates were considered in both
@crump2009dealing and @Li-et-al:2018 and 50 covariates were used in
@Rothe:2017. In our exercise, we constructed the same 72 covariates.
A cleaned version of the dataset is available in the package. 


```{r}
  Y <- RHC[,"survival"]
  D <- RHC[,"RHC"]
  X <- as.matrix(RHC[,-c(1,2)])
```


As in the aforementioned papers, we estimated the propensity scores by a
logit model with all 72 covariates being added linearly.


```{r}
  # Logit estimation of propensity score
  glm_ps <- stats::glm(D~X,family=binomial("logit"))
  ps <- glm_ps$fitted.values
  ps_treated <- ps[D==1]
  ps_control <- ps[D==0]
  # Plotting histograms of propensity scores
  df <- data.frame(cbind(D,ps))
  colnames(df)<-c("RHC","PS")
  df$RHC <- as.factor(df$RHC)
  levels(df$RHC) <- c("No RHC (Control)", "RHC (Treated)")
  
  ggplot2::ggplot(df, ggplot2::aes(x=PS, color=RHC, fill=RHC)) +
    ggplot2::geom_histogram(breaks=seq(0,1,0.1),alpha=0.5,position="identity")
```

The figure above shows the
histograms of estimated propensity scores for treated and control
groups. It is very similar to Fig.1 in @crump2009dealing and to Figure
2 in @Rothe:2017. The support of the estimated propensity scores are
almost on the unit interval for both treated and control units, although
there is some visual evidence on limited overlap (that is, control units
have much fewer propensity scores close to 1).

## Bounding the Average Treatment Effect on the Treated

In this section, we focus on ATT. We first estimate ATT by the
normalized inverse probability weighted estimator: 
$$\begin{aligned}
\widehat{\text{ATT}}_{\text{PS}} 
:= \frac{\sum_{i=1}^n D_i Y_i}{\sum_{i=1}^n D_i}
- \frac{\sum_{i=1}^n (1-D_i) W_i Y_i}{\sum_{i=1}^n (1-D_i) W_i},
\end{aligned}$$
where $W_i := \widehat{p}(X_i)/[1-\widehat{p}(X_i)]$ and
$\widehat{p}(X_i)$ is the estimated propensity score for observation $i$
based on the logit model described above. 
See, e.g., equation (3) and discussions in @busso2014new for
    details of the normalized inverse probability weighted ATT
    estimator.
The estimator
$\widehat{\text{ATT}}_{\text{PS}}$ requires that the assumed propensity
score model is correctly specified and the overlap condition is
satisfied. The resulting estimate is
$\widehat{\text{ATT}}_{\text{PS}}  = -0.0639$.

```{r}
  # ATT normalized estimation
  y1_att <- mean(D*Y)/mean(D)
  att_wgt <- ps/(1-ps)
  y0_att_num <- mean((1-D)*att_wgt*Y)
  y0_att_den <- mean((1-D)*att_wgt)
  y0_att <- y0_att_num/y0_att_den
  att_ps <- y1_att - y0_att
  print(att_ps)
```


We now turn to our methods. As before, we take the reference propensity score to be
$\widehat{p}_{\text{RPS}}(X_i) = n^{-1} \sum_{i=1}^n D_i$ for each
observation $i$. That is, we assign the sample proportion of the treated
to the reference propensity scores uniformly for all observations. Of
course, this is likely to be misspecified; however, it has the advantage
that $1/\widehat{p}_{\text{RPS}}(X_i)$ is never close to 0 or 1. 

```{r}
  rps <- rep(mean(D),length(D))  
```

The
resulting inverse reference-propensity-score weighted ATT
estimator is 
$$\begin{aligned}
\widehat{\text{ATT}}_{\text{RPS}} 
:= \frac{\sum_{i=1}^n D_i Y_i}{\sum_{i=1}^n D_i}
- \frac{\sum_{i=1}^n (1-D_i) Y_i}{\sum_{i=1}^n (1-D_i)}
= -0.0507.
\end{aligned}$$ 

```{r}
  att_rps <- mean(D*Y)/mean(D) - mean((1-D)*Y)/mean(1-D)
  print(att_rps)
```

When the sample proportion is used as the propensity score estimator, there is no difference between
unnormalized and normalized versions of ATT estimates. In fact, it is simply the mean difference between treatment and control groups. 

```{r}
   Xunique <- mgcv::uniquecombs(X) # A matrix of unique rows from X
   print(c("no. of unique rows:", nrow(Xunique))) 
   print(c("sample size       :", nrow(X)))   
```

Note that none of the covariates in the observed sample are identical. We therefore implement hierarchical, agglomerative clustering with complete linkage. 

We show empirical results using the default option.

```{r}
  summary(attbounds(Y, D, X, rps))
```

to check sensitivity with respect to tuning parameters, we vary $L$ and $Q$. 

```{r, eval=FALSE}
  # Bounding ATT: sensitivity analysis
  # This chunk is not evaluated by default because the analysis is time-intensive.
  nhc_set <- c(5, 10, 20)
  results_att <- {}

  for (hc in nhc_set){
    nhc <- ceiling(length(Y)/hc)

    for (q in c(1,2,3,4)){
      res <- attbounds(Y, D, X, rps, Q = q, n_hc = nhc)
      results_att <- rbind(results_att,c(hc,q,res$est_lb,res$est_ub,res$ci_lb,res$ci_ub))
    }
  }
  colnames(results_att) = c("L","Q","LB","UB","CI-LB","CI-UB")
  print(results_att, digits = 3)
```


The table below reports
estimation results of ATT bounds for extended values of $L$ and $Q$.
When $Q=1$, our estimated bounds correspond to Manski bounds, which
includes zero and is wide with the interval length of almost one in all
cases of $L$. Our bounds with $Q=1$ are different across $L$ because we
apply hierarchical clustering before obtaining Manski bounds. With
$Q=2$, the bounds shrink so that the estimated upper bound is zero for
all cases of $L$; with $Q = 3$, they shrink even further so that the
upper end point of the 95% confidence interval excludes zero. Among
three different values of $L$, the case of $L=5$ gives the tightest
confidence interval but in this case, the lower bound is larger than the
upper bound, indicating that the estimates might be biased. In view of
that, we take the bound estimates with $L=10$ as our preferred estimates
$[-0.077,  -0.039]$ with the 95% confidence interval $[-0.117,0.006]$.
When $Q=4$, the lower bound estimates exceed the upper bound estimates
with $L = 5, 10$. However, the estimates with $L = 20$ give almost
identical results to our preferred estimates. It seems that the pairs of
$(L, Q) = (10, 3)$ or $(L, Q) = (20, 4)$ provide reasonable estimates.


     L   Q       LB       UB    CI-LB    CI-UB
  ---- --- -------- -------- -------- --------
     5   1   -0.638    0.282   -0.700    0.330
         2   -0.131   -0.000   -0.174    0.033
         3   -0.034   -0.048   -0.076   -0.007
         4   -0.006   -0.073   -0.079   -0.006
    10   1   -0.664    0.307   -0.766    0.376
         2   -0.169    0.004   -0.216    0.039
         3   -0.077   -0.039   -0.117   -0.006
         4   -0.049   -0.057   -0.090   -0.016
    20   1   -0.675    0.316   -0.843    0.430
         2   -0.178   -0.005   -0.238    0.034
         3   -0.099   -0.046   -0.149   -0.007
         4   -0.065   -0.060   -0.112   -0.017
   ---- --- -------- -------- -------- --------

Table: ATT Bounds: Right Heart Catheterization Study


The study of @Connors1996 offered a conclusion that RHC could cause an
increase in patient mortality. Based on our preferred estimates, we can
exclude positive effects with confidence. This conclusion is based
solely on the unconfoundedness condition, but not on the overlap
condition, nor on the correct specification of the logit model. Overall,
our estimates seem to be consistent with the qualitative findings in
@Connors1996.

## Bounding the Average Treatment Effect 

We now turn to bounds on ATE. Using again the sample proportion of the treated as the reference propensity score,
we bound the ATE.

We start with $Q=1$.

```{r}
  summary(atebounds(Y, D, X, rps, Q = 1))
```

We now consider $Q=2$ 

```{r}
  summary(atebounds(Y, D, X, rps, Q = 2))
```

and $Q=3$. 

```{r}
  summary(atebounds(Y, D, X, rps, Q = 3))
```

Finally, we take $Q = 4$.

```{r}
  summary(atebounds(Y, D, X, rps, Q = 4))
```

Overall, the results are similar to ATT. 

# Case Study 3: EFM

The electronic fetal monitoring (EFM) and cesarean section (CS) dataset from @EFMdata consists of observations on 14,484 women who delivered at Beth Israel Hospital, Boston from January 1970 to December 1975. The purpose of the study is to evaluate the impact of EFM on cesarean section (CS) rates. @EFMdata report that relevant confounding factors are: nulliparity (nullipar), arrest of labor progression (arrest), malpresentation (breech), and year of study (year). The dataset included in the R package is from the supplementary materials of @RRW-JASA, who used this dataset to illustrate their proposed methods for modeling and estimating relative risk and risk difference. In this dataset, all covariates are discrete. 

```{r}
  Y <- EFM[,"cesarean"]
  D <- EFM[,"monitor"]
  X <- as.matrix(EFM[,c("arrest", "breech", "nullipar", "year")])
  year <- EFM[,"year"] 
```

```{r}
  ate_rps <- mean(D*Y)/mean(D) - mean((1-D)*Y)/mean(1-D)
  print(ate_rps)
```

We take the reference propensity score to be the sample proportion of the treatment.

```{r}
  rps <- rep(mean(D),length(D))  
  print(rps[1])
```

## Bounding the Average Treatment Effect 

Using again the sample proportion of the treated as the reference propensity score,
we bound the ATE.

We start with $Q=1$.

```{r}
  summary(atebounds(Y, D, X, rps, Q = 1, x_discrete = TRUE))
```

We now consider $Q=2$ 

```{r}
  summary(atebounds(Y, D, X, rps, Q = 2, x_discrete = TRUE))
```

and $Q=3$. 

```{r}
  summary(atebounds(Y, D, X, rps, Q = 3, x_discrete = TRUE))
```

In this example, the reference propensity score is close to 0.5, thus implying that the results will be robust even if we take a very large $Q$. In view of that, we take  $Q = 5, 10, 20, 50, 100$.

```{r}
  summary(atebounds(Y, D, X, rps, Q = 5, x_discrete = TRUE))
  summary(atebounds(Y, D, X, rps, Q = 10, x_discrete = TRUE))
  summary(atebounds(Y, D, X, rps, Q = 20, x_discrete = TRUE))
  summary(atebounds(Y, D, X, rps, Q = 50, x_discrete = TRUE))
  summary(atebounds(Y, D, X, rps, Q = 100, x_discrete = TRUE))
```

Overall, the empirical results suggest that there is no significant effect of EFM on cesarean section rates.

## References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_RHC.R
\docType{data}
\name{RHC}
\alias{RHC}
\title{RHC}
\format{
A data frame with 5735 rows and 74 variables:
\describe{
\item{survival}{Outcome: 1 if a patient survived after 30 days of admission, and 0 if a patient died within 30 days}
\item{RHC}{Treatment: 1 if RHC was applied within 24 hours of admission, and 0 otherwise.}
\item{age}{Age in years}
\item{edu}{Years of education}
\item{cardiohx}{Cardiovascular symptoms}
\item{chfhx}{Congestive Heart Failure}
\item{dementhx}{Dementia, stroke or cerebral infarct, Parkinson’s disease}
\item{psychhx}{Psychiatric history, active psychosis or severe depression}
\item{chrpulhx}{Chronic pulmonary disease, severe pulmonary disease}
\item{renalhx}{Chronic renal disease, chronic hemodialysis or peritoneal dialysis}
\item{liverhx}{Cirrhosis, hepatic failure}
\item{gibledhx}{Upper GI bleeding}
\item{malighx}{Solid tumor, metastatic disease, chronic leukemia/myeloma, acute leukemia, lymphoma}
\item{immunhx}{Immunosuppression, organ transplant, HIV, Diabetes Mellitus, Connective Tissue Disease}
\item{transhx}{transfer (> 24 hours) from another hospital}
\item{amihx}{Definite myocardial infarction}
\item{das2d3pc}{DASI - Duke Activity Status Index}
\item{surv2md1}{Estimate of prob. of surviving 2 months}
\item{aps1}{APACHE score}
\item{scoma1}{Glasgow coma score}
\item{wtkilo1}{Weight}
\item{temp1}{Temperature}
\item{meanbp1}{Mean Blood Pressure}
\item{resp1}{Respiratory Rate}
\item{hrt1}{Heart Rate}
\item{pafi1}{PaO2/FI02 ratio}
\item{paco21}{PaCO2}
\item{ph1}{PH}
\item{wblc1}{WBC}
\item{hema1}{Hematocrit}
\item{sod1}{Sodium}
\item{pot1}{Potassium}
\item{crea1}{Creatinine}
\item{bili1}{Bilirubin}
\item{alb1}{Albumin}
\item{cat1_CHF}{1 if the primary disease category is CHF, and 0 otherwise (Omitted category = ARF).}
\item{cat1_Cirrhosis}{1 if the primary disease category is Cirrhosis, and 0 otherwise (Omitted category = ARF).}
\item{cat1_Colon_Cancer}{1 if the primary disease category is Colon Cancer, and 0 otherwise (Omitted category = ARF).}
\item{cat1_Coma}{1 if the primary disease category is Coma, and 0 otherwise (Omitted category = ARF).}
\item{cat1_COPD}{1 if the primary disease category is COPD, and 0 otherwise (Omitted category = ARF).}
\item{cat1_Lung_Cancer}{1 if the primary disease category is Lung Cancer, and 0 otherwise (Omitted category = ARF).}
\item{cat1_MOSF_Malignancy}{1 if the primary disease category is MOSF w/Malignancy, and 0 otherwise (Omitted category = ARF).}
\item{cat1_MOSF_Sepsis}{1 if the primary disease category is MOSF w/Sepsis, and 0 otherwise (Omitted category = ARF).}
\item{ca_Metastatic}{1 if cancer is metastatic, and 0 otherwise (Omitted category = no cancer).}
\item{ca_Yes}{1 if cancer is localized, and 0 otherwise (Omitted category = no cancer).}
\item{ninsclas_Medicaid}{1 if medical insurance category is Medicaid, and 0 otherwise (Omitted category = Private).}
\item{ninsclas_Medicare}{1 if medical insurance category is Medicare, and 0 otherwise (Omitted category = Private).}
\item{ninsclas_Medicare_and_Medicaid}{1 if medical insurance category is Medicare & Medicaid, and 0 otherwise (Omitted category = Private).}
\item{ninsclas_No_insurance}{1 if medical insurance category is No Insurance, and 0 otherwise (Omitted category = Private).}
\item{ninsclas_Private_and_Medicare}{1 if medical insurance category is Private & Medicare, and 0 otherwise (Omitted category = Private).}
\item{race_black}{1 if Black, and 0 otherwise (Omitted category = White).}
\item{race_other}{1 if Other, and 0 otherwise (Omitted category = White).}
\item{income3}{1 if Income >$50k, and 0 otherwise (Omitted category = under $11k).}
\item{income1}{1 if Income $11–$25k, and 0 otherwise (Omitted category = under $11k).}
\item{income2}{1 if Income $25–$50k, and 0 otherwise (Omitted category = under $11k).}
\item{resp_Yes}{Respiratory diagnosis}
\item{card_Yes}{Cardiovascular diagnosis}
\item{neuro_Yes}{Neurological diagnosis}
\item{gastr_Yes}{Gastrointestinal diagnosis}
\item{renal_Yes}{Renal diagnosis}
\item{meta_Yes}{Metabolic diagnosis}
\item{hema_Yes}{Hematological diagnosis}
\item{seps_Yes}{Sepsis diagnosis}
\item{trauma_Yes}{Trauma diagnosis}
\item{ortho_Yes}{Orthopedic diagnosis}
\item{dnr1_Yes}{Do Not Resuscitate status on day 1}
\item{sex_Female}{Female}
\item{cat2_Cirrhosis}{1 if the secondary disease category is Cirrhosis, and 0 otherwise (Omitted category = NA).}
\item{cat2_Colon_Cancer}{1 if secondary disease category is Colon Cancer, and 0 otherwise (Omitted category = NA).}
\item{cat2_Coma}{1 if the secondary disease category is Coma, and 0 otherwise (Omitted category = NA).}
\item{cat2_Lung_Cancer}{1 if the secondary disease category is Lung Cancer, and 0 otherwise (Omitted category = NA).}
\item{cat2_MOSF_Malignancy}{1 if the secondary disease category is MOSF w/Malignancy, and 0 otherwise (Omitted category = NA).}
\item{cat2_MOSF_Sepsis}{1 if the secondary disease category is MOSF w/Sepsis, and 0 otherwise (Omitted category = NA).}
\item{wt0}{weight = 0 (missing)}
}
}
\source{
The dataset is publicly available on the Vanderbilt Biostatistics website at 
\url{https://hbiostat.org/data/}.
}
\usage{
RHC
}
\description{
The right heart catheterization (RHC) dataset is publicly available on the Vanderbilt Biostatistics website.
RHC is a diagnostic procedure for directly measuring cardiac function in critically ill patients. 
The dependent variable is 1 if a patient survived after 30 days of admission, 0 if a patient died within 30 days.
The treatment variable is 1 if RHC was applied within 24 hours of admission, and 0 otherwise.
The sample size was n = 5735, and 2184 patients were treated with RHC. 
Connors et al. (1996) used a propensity score matching approach to study the efficacy of RHC,
using data from the observational study called SUPPORT (Murphy and Cluff, 1990). 
Many authors used this dataset subsequently.
The 72 covariates are constructed, following Hirano and Imbens (2001).
}
\references{
Connors, A.F., Speroff, T., Dawson, N.V., Thomas, C., Harrell, F.E., Wagner, D., Desbiens, N., Goldman, L., Wu, A.W., Califf, R.M. and Fulkerson, W.J., 1996. 
The effectiveness of right heart catheterization in the initial care of critically III patients. JAMA, 276(11), pp.889-897.
\doi{10.1001/jama.1996.03540110043030}

Hirano, K., Imbens, G.W. Estimation of Causal Effects using Propensity Score Weighting: An Application to Data on Right Heart Catheterization, 2001.
Health Services & Outcomes Research Methodology 2, pp.259–278. 
\doi{10.1023/A:1020371312283}

D. J. Murphy, L. E. Cluff, SUPPORT: Study to understand prognoses and preferences for outcomes and risks of treatments—study design, 1990.
Journal of Clinical Epidemiology, 43, pp. 1S–123S
\url{https://www.jclinepi.com/issue/S0895-4356(00)X0189-8}
.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_EFM.R
\docType{data}
\name{EFM}
\alias{EFM}
\title{EFM}
\format{
A data frame with 14484 rows and 6 variables:
\describe{
\item{cesarean}{Outcome: 1 if delivery was via cesarean section; 0 otherwise}
\item{monitor}{Treatment: 1 if electronic fetal monitoring (EFM) was used; 0 otherwise}
\item{arrest}{Covariate: 1 = arrest of labor progression; 0 otherwise}
\item{breech}{Covariate: 1 = malpresentation (breech); 0 otherwise}
\item{nullipar}{Covariate: 1 = nulliparity; 0 otherwise}
\item{year}{Year of study: 0,...,5 (actual values are 1970,...,1975)}
}
}
\source{
The dataset from Neutra, Greenland, and Friedman (1980) is available 
as part of supplementary materials of Richardson, Robins, and Wang (2017) 
on Journal of the American Statistical Association website at 
\doi{10.1080/01621459.2016.1192546}.
}
\usage{
EFM
}
\description{
The electronic fetal monitoring (EFM) and cesarean section (CS) dataset 
from Neutra, Greenland, and Friedman (1980) consists of observations on 14,484 women 
who delivered at Beth Israel Hospital, Boston from January 1970 to December 1975. 
The purpose of the study is to evaluate the impact of EFM on cesarean section (CS) rates. 
It is found by Neutra, Greenland, and Friedman (1980) that relevant confounding factors are: 
nulliparity (nullipar), arrest of labor progression (arrest), malpresentation (breech), and year of study (year). 
The dataset provided in the R package is from the supplementary materials of Richardson, Robins, and Wang (2017), 
who used this dataset to illustrate their proposed methods 
for modeling and estimating relative risk and risk difference.
}
\references{
Neutra, R.R., Greenland, S. and Friedman, E.A., 1980. 
Effect of fetal monitoring on cesarean section rates. 
Obstetrics and gynecology, 55(2), pp.175-180.

Richardson, T.S., Robins, J.M. and Wang, L., 2017. 
On modeling and estimation for the relative risk and risk difference. 
Journal of the American Statistical Association, 112(519), pp.1121-1130.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summary.ATbounds.R
\name{summary.ATbounds}
\alias{summary.ATbounds}
\title{Summary method for ATbounds objects}
\usage{
\method{summary}{ATbounds}(object, ...)
}
\arguments{
\item{object}{ATbounds object}

\item{...}{Additional arguments for summary generic}
}
\value{
A summary is produced with bounds estimates and confidence intervals.
In addition, it has the following elements.
\item{Lower_Bound}{lower bound estimate and lower end point of the confidence interval}
\item{Upper_Bound}{upper bound estimate and upper end point of the confidence interval}
}
\description{
Produce a summary for an ATbounds object.
}
\examples{
  Y <- RHC[,"survival"]
  D <- RHC[,"RHC"]
  X <- RHC[,c("age","edu")]
  rps <- rep(mean(D),length(D))
  results_ate <- atebounds(Y, D, X, rps, Q = 3)
  summary(results_ate)

}
\references{
Sokbae Lee and Martin Weidner. Bounding Treatment Effects by Pooling Limited Information across Observations. Forthcoming at the Journal of Econometrics.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/attbounds.R
\name{attbounds}
\alias{attbounds}
\title{Bounding the average treatment effect on the treated (ATT)}
\usage{
attbounds(
  Y,
  D,
  X,
  rps,
  Q = 3L,
  studentize = TRUE,
  alpha = 0.05,
  x_discrete = FALSE,
  n_hc = NULL
)
}
\arguments{
\item{Y}{n-dimensional vector of binary outcomes}

\item{D}{n-dimensional vector of binary treatments}

\item{X}{n by p matrix of covariates}

\item{rps}{n-dimensional vector of the reference propensity score}

\item{Q}{bandwidth parameter that determines the maximum number of observations for pooling information (default: Q = 3)}

\item{studentize}{TRUE if X is studentized elementwise and FALSE if not (default: TRUE)}

\item{alpha}{(1-alpha) nominal coverage probability for the confidence interval of ATE (default: 0.05)}

\item{x_discrete}{TRUE if the distribution of X is discrete and FALSE otherwise (default: FALSE)}

\item{n_hc}{number of hierarchical clusters to discretize non-discrete covariates; relevant only if x_discrete is FALSE.
The default choice is n_hc = ceiling(length(Y)/10), so that there are 10 observations in each cluster on average.}
}
\value{
An S3 object of type "ATbounds". The object has the following elements.
\item{call}{a call in which all of the specified arguments are specified by their full names}
\item{type}{ATT}
\item{cov_prob}{Confidence level: 1-alpha}
\item{est_lb}{estimate of the lower bound on ATT, i.e. E[Y(1) - Y(0) | D = 1]}
\item{est_ub}{estimate of the upper bound on ATT, i.e. E[Y(1) - Y(0) | D = 1]}
\item{est_rps}{the point estimate of ATT using the reference propensity score}
\item{se_lb}{standard error for the estimate of the lower bound on ATT}
\item{se_ub}{standard error for the estimate of the upper bound on ATT}
\item{ci_lb}{the lower end point of the confidence interval for ATT}
\item{ci_ub}{the upper end point of the confidence interval for ATT}
}
\description{
Bounds the average treatment effect on the treated (ATT) under the unconfoundedness assumption without the overlap condition.
}
\examples{
  Y <- RHC[,"survival"]
  D <- RHC[,"RHC"]
  X <- RHC[,c("age","edu")]
  rps <- rep(mean(D),length(D))
  results_att <- attbounds(Y, D, X, rps, Q = 3)

}
\references{
Sokbae Lee and Martin Weidner. Bounding Treatment Effects by Pooling Limited Information across Observations. Forthcoming at the Journal of Econometrics.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulation_dgp.R
\name{simulation_dgp}
\alias{simulation_dgp}
\title{Simulating observations from the data-generating process considered in Lee and Weidner}
\usage{
simulation_dgp(n, ps_spec = "overlap", x_discrete = FALSE)
}
\arguments{
\item{n}{sample size}

\item{ps_spec}{specification of the propensity score: "overlap" or "non-overlap" (default: "overlap")}

\item{x_discrete}{TRUE if the distribution of the covariate is uniform on the grid -3.0, -2.9, ..., 3.0 and
FALSE if the distribution of the covariate is uniform on [-3,3] (default: FALSE)}
}
\value{
An S3 object of type "ATbounds". The object has the following elements.
\item{outcome}{n observations of binary outcomes}
\item{treat}{n observations of binary treatments}
\item{covariate}{n observations of a scalar covariate}
\item{ate_oracle}{the sample analog of E[Y(1) - Y(0)]}
\item{att_oracle}{the sample analog of E[D * (Y(1) - Y(0)) | D = 1]}
}
\description{
Simulates observations from the data-generating process considered in Lee and Weidner
}
\examples{
  data <- simulation_dgp(100, ps_spec = "overlap")
  y <- data$outcome
  d <- data$treat
  x <- data$covariate
  ate <- data$ate_oracle
  att <- data$att_oracle

}
\references{
Sokbae Lee and Martin Weidner. Bounding Treatment Effects by Pooling Limited Information across Observations. Forthcoming at the Journal of Econometrics.
}
